var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var produce_exports = {};
__export(produce_exports, {
  ProduceJWT: () => ProduceJWT
});
var import_epoch = __toESM(require("../lib/epoch.js"));
var import_is_object = __toESM(require("../lib/is_object.js"));
var import_secs = __toESM(require("../lib/secs.js"));
class ProduceJWT {
  constructor(payload) {
    if (!(0, import_is_object.default)(payload)) {
      throw new TypeError("JWT Claims Set MUST be an object");
    }
    this._payload = payload;
  }
  setIssuer(issuer) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { iss: issuer });
    return this;
  }
  setSubject(subject) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { sub: subject });
    return this;
  }
  setAudience(audience) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { aud: audience });
    return this;
  }
  setJti(jwtId) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { jti: jwtId });
    return this;
  }
  setNotBefore(input) {
    if (typeof input === "number") {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { nbf: input });
    } else {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { nbf: (0, import_epoch.default)(new Date()) + (0, import_secs.default)(input) });
    }
    return this;
  }
  setExpirationTime(input) {
    if (typeof input === "number") {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { exp: input });
    } else {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { exp: (0, import_epoch.default)(new Date()) + (0, import_secs.default)(input) });
    }
    return this;
  }
  setIssuedAt(input) {
    if (typeof input === "undefined") {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { iat: (0, import_epoch.default)(new Date()) });
    } else {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { iat: input });
    }
    return this;
  }
}
module.exports = __toCommonJS(produce_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ProduceJWT
});
