var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var unsecured_exports = {};
__export(unsecured_exports, {
  UnsecuredJWT: () => UnsecuredJWT
});
var base64url = __toESM(require("../runtime/base64url.js"));
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_errors = require("../util/errors.js");
var import_jwt_claims_set = __toESM(require("../lib/jwt_claims_set.js"));
var import_produce = require("./produce.js");
class UnsecuredJWT extends import_produce.ProduceJWT {
  encode() {
    const header = base64url.encode(JSON.stringify({ alg: "none" }));
    const payload = base64url.encode(JSON.stringify(this._payload));
    return `${header}.${payload}.`;
  }
  static decode(jwt, options) {
    if (typeof jwt !== "string") {
      throw new import_errors.JWTInvalid("Unsecured JWT must be a string");
    }
    const { 0: encodedHeader, 1: encodedPayload, 2: signature, length } = jwt.split(".");
    if (length !== 3 || signature !== "") {
      throw new import_errors.JWTInvalid("Invalid Unsecured JWT");
    }
    let header;
    try {
      header = JSON.parse(import_buffer_utils.decoder.decode(base64url.decode(encodedHeader)));
      if (header.alg !== "none")
        throw new Error();
    } catch {
      throw new import_errors.JWTInvalid("Invalid Unsecured JWT");
    }
    const payload = (0, import_jwt_claims_set.default)(header, base64url.decode(encodedPayload), options);
    return { payload, header };
  }
}
module.exports = __toCommonJS(unsecured_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  UnsecuredJWT
});
