var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var aeskw_exports = {};
__export(aeskw_exports, {
  unwrap: () => unwrap,
  wrap: () => wrap
});
var import_buffer = require("buffer");
var import_crypto = require("crypto");
var import_errors = require("../util/errors.js");
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_webcrypto = require("./webcrypto.js");
var import_crypto_key = require("../lib/crypto_key.js");
var import_is_key_object = __toESM(require("./is_key_object.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_ciphers = __toESM(require("./ciphers.js"));
var import_is_key_like = require("./is_key_like.js");
function checkKeySize(key, alg) {
  if (key.symmetricKeySize << 3 !== parseInt(alg.slice(1, 4), 10)) {
    throw new TypeError(`Invalid key size for alg: ${alg}`);
  }
}
function ensureKeyObject(key, alg, usage) {
  if ((0, import_is_key_object.default)(key)) {
    return key;
  }
  if (key instanceof Uint8Array) {
    return (0, import_crypto.createSecretKey)(key);
  }
  if ((0, import_webcrypto.isCryptoKey)(key)) {
    (0, import_crypto_key.checkEncCryptoKey)(key, alg, usage);
    return import_crypto.KeyObject.from(key);
  }
  throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types, "Uint8Array"));
}
const wrap = (alg, key, cek) => {
  const size = parseInt(alg.slice(1, 4), 10);
  const algorithm = `aes${size}-wrap`;
  if (!(0, import_ciphers.default)(algorithm)) {
    throw new import_errors.JOSENotSupported(`alg ${alg} is not supported either by JOSE or your javascript runtime`);
  }
  const keyObject = ensureKeyObject(key, alg, "wrapKey");
  checkKeySize(keyObject, alg);
  const cipher = (0, import_crypto.createCipheriv)(algorithm, keyObject, import_buffer.Buffer.alloc(8, 166));
  return (0, import_buffer_utils.concat)(cipher.update(cek), cipher.final());
};
const unwrap = (alg, key, encryptedKey) => {
  const size = parseInt(alg.slice(1, 4), 10);
  const algorithm = `aes${size}-wrap`;
  if (!(0, import_ciphers.default)(algorithm)) {
    throw new import_errors.JOSENotSupported(`alg ${alg} is not supported either by JOSE or your javascript runtime`);
  }
  const keyObject = ensureKeyObject(key, alg, "unwrapKey");
  checkKeySize(keyObject, alg);
  const cipher = (0, import_crypto.createDecipheriv)(algorithm, keyObject, import_buffer.Buffer.alloc(8, 166));
  return (0, import_buffer_utils.concat)(cipher.update(encryptedKey), cipher.final());
};
module.exports = __toCommonJS(aeskw_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  unwrap,
  wrap
});
