var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var asn1_exports = {};
__export(asn1_exports, {
  fromPKCS8: () => fromPKCS8,
  fromSPKI: () => fromSPKI,
  toPKCS8: () => toPKCS8,
  toSPKI: () => toSPKI
});
var import_crypto = require("crypto");
var import_buffer = require("buffer");
var import_webcrypto = require("./webcrypto.js");
var import_is_key_object = __toESM(require("./is_key_object.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
const genericExport = (keyType, keyFormat, key) => {
  let keyObject;
  if ((0, import_webcrypto.isCryptoKey)(key)) {
    if (!key.extractable) {
      throw new TypeError("CryptoKey is not extractable");
    }
    keyObject = import_crypto.KeyObject.from(key);
  } else if ((0, import_is_key_object.default)(key)) {
    keyObject = key;
  } else {
    throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types));
  }
  if (keyObject.type !== keyType) {
    throw new TypeError(`key is not a ${keyType} key`);
  }
  return keyObject.export({ format: "pem", type: keyFormat });
};
const toSPKI = (key) => {
  return genericExport("public", "spki", key);
};
const toPKCS8 = (key) => {
  return genericExport("private", "pkcs8", key);
};
const fromPKCS8 = (pem) => (0, import_crypto.createPrivateKey)({
  key: import_buffer.Buffer.from(pem.replace(/(?:-----(?:BEGIN|END) PRIVATE KEY-----|\s)/g, ""), "base64"),
  type: "pkcs8",
  format: "der"
});
const fromSPKI = (pem) => (0, import_crypto.createPublicKey)({
  key: import_buffer.Buffer.from(pem.replace(/(?:-----(?:BEGIN|END) PUBLIC KEY-----|\s)/g, ""), "base64"),
  type: "spki",
  format: "der"
});
module.exports = __toCommonJS(asn1_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  fromPKCS8,
  fromSPKI,
  toPKCS8,
  toSPKI
});
