var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var asn1_sequence_decoder_exports = {};
__export(asn1_sequence_decoder_exports, {
  default: () => Asn1SequenceDecoder
});
const tagInteger = 2;
const tagSequence = 48;
class Asn1SequenceDecoder {
  constructor(buffer) {
    if (buffer[0] !== tagSequence) {
      throw new TypeError();
    }
    this.buffer = buffer;
    this.offset = 1;
    const len = this.decodeLength();
    if (len !== buffer.length - this.offset) {
      throw new TypeError();
    }
  }
  decodeLength() {
    let length = this.buffer[this.offset++];
    if (length & 128) {
      const nBytes = length & ~128;
      length = 0;
      for (let i = 0; i < nBytes; i++)
        length = length << 8 | this.buffer[this.offset + i];
      this.offset += nBytes;
    }
    return length;
  }
  unsignedInteger() {
    if (this.buffer[this.offset++] !== tagInteger) {
      throw new TypeError();
    }
    let length = this.decodeLength();
    if (this.buffer[this.offset] === 0) {
      this.offset++;
      length--;
    }
    const result = this.buffer.slice(this.offset, this.offset + length);
    this.offset += length;
    return result;
  }
  end() {
    if (this.offset !== this.buffer.length) {
      throw new TypeError();
    }
  }
}
module.exports = __toCommonJS(asn1_sequence_decoder_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
