var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var ecdhes_exports = {};
__export(ecdhes_exports, {
  deriveKey: () => deriveKey,
  ecdhAllowed: () => ecdhAllowed,
  generateEpk: () => generateEpk
});
var import_crypto = require("crypto");
var import_util = require("util");
var import_get_named_curve = __toESM(require("./get_named_curve.js"));
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_digest = __toESM(require("./digest.js"));
var import_errors = require("../util/errors.js");
var import_webcrypto = require("./webcrypto.js");
var import_crypto_key = require("../lib/crypto_key.js");
var import_is_key_object = __toESM(require("./is_key_object.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
const generateKeyPair = (0, import_util.promisify)(import_crypto.generateKeyPair);
async function deriveKey(publicKee, privateKee, algorithm, keyLength, apu = new Uint8Array(0), apv = new Uint8Array(0)) {
  let publicKey;
  if ((0, import_webcrypto.isCryptoKey)(publicKee)) {
    (0, import_crypto_key.checkEncCryptoKey)(publicKee, "ECDH-ES");
    publicKey = import_crypto.KeyObject.from(publicKee);
  } else if ((0, import_is_key_object.default)(publicKee)) {
    publicKey = publicKee;
  } else {
    throw new TypeError((0, import_invalid_key_input.default)(publicKee, ...import_is_key_like.types));
  }
  let privateKey;
  if ((0, import_webcrypto.isCryptoKey)(privateKee)) {
    (0, import_crypto_key.checkEncCryptoKey)(privateKee, "ECDH-ES", "deriveBits", "deriveKey");
    privateKey = import_crypto.KeyObject.from(privateKee);
  } else if ((0, import_is_key_object.default)(privateKee)) {
    privateKey = privateKee;
  } else {
    throw new TypeError((0, import_invalid_key_input.default)(privateKee, ...import_is_key_like.types));
  }
  const value = (0, import_buffer_utils.concat)((0, import_buffer_utils.lengthAndInput)(import_buffer_utils.encoder.encode(algorithm)), (0, import_buffer_utils.lengthAndInput)(apu), (0, import_buffer_utils.lengthAndInput)(apv), (0, import_buffer_utils.uint32be)(keyLength));
  const sharedSecret = (0, import_crypto.diffieHellman)({ privateKey, publicKey });
  return (0, import_buffer_utils.concatKdf)(import_digest.default, sharedSecret, keyLength, value);
}
async function generateEpk(kee) {
  let key;
  if ((0, import_webcrypto.isCryptoKey)(kee)) {
    key = import_crypto.KeyObject.from(kee);
  } else if ((0, import_is_key_object.default)(kee)) {
    key = kee;
  } else {
    throw new TypeError((0, import_invalid_key_input.default)(kee, ...import_is_key_like.types));
  }
  switch (key.asymmetricKeyType) {
    case "x25519":
      return generateKeyPair("x25519");
    case "x448": {
      return generateKeyPair("x448");
    }
    case "ec": {
      const namedCurve = (0, import_get_named_curve.default)(key);
      return generateKeyPair("ec", { namedCurve });
    }
    default:
      throw new import_errors.JOSENotSupported("Invalid or unsupported EPK");
  }
}
const ecdhAllowed = (key) => ["P-256", "P-384", "P-521", "X25519", "X448"].includes((0, import_get_named_curve.default)(key));
module.exports = __toCommonJS(ecdhes_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  deriveKey,
  ecdhAllowed,
  generateEpk
});
