var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var rsaes_exports = {};
__export(rsaes_exports, {
  decrypt: () => decrypt,
  encrypt: () => encrypt
});
var import_crypto = require("crypto");
var import_check_modulus_length = __toESM(require("./check_modulus_length.js"));
var import_webcrypto = require("./webcrypto.js");
var import_crypto_key = require("../lib/crypto_key.js");
var import_is_key_object = __toESM(require("./is_key_object.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
const checkKey = (key, alg) => {
  if (key.asymmetricKeyType !== "rsa") {
    throw new TypeError("Invalid key for this operation, its asymmetricKeyType must be rsa");
  }
  (0, import_check_modulus_length.default)(key, alg);
};
const resolvePadding = (alg) => {
  switch (alg) {
    case "RSA-OAEP":
    case "RSA-OAEP-256":
    case "RSA-OAEP-384":
    case "RSA-OAEP-512":
      return import_crypto.constants.RSA_PKCS1_OAEP_PADDING;
    case "RSA1_5":
      return import_crypto.constants.RSA_PKCS1_PADDING;
    default:
      return void 0;
  }
};
const resolveOaepHash = (alg) => {
  switch (alg) {
    case "RSA-OAEP":
      return "sha1";
    case "RSA-OAEP-256":
      return "sha256";
    case "RSA-OAEP-384":
      return "sha384";
    case "RSA-OAEP-512":
      return "sha512";
    default:
      return void 0;
  }
};
function ensureKeyObject(key, alg, ...usages) {
  if ((0, import_is_key_object.default)(key)) {
    return key;
  }
  if ((0, import_webcrypto.isCryptoKey)(key)) {
    (0, import_crypto_key.checkEncCryptoKey)(key, alg, ...usages);
    return import_crypto.KeyObject.from(key);
  }
  throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types));
}
const encrypt = (alg, key, cek) => {
  const padding = resolvePadding(alg);
  const oaepHash = resolveOaepHash(alg);
  const keyObject = ensureKeyObject(key, alg, "wrapKey", "encrypt");
  checkKey(keyObject, alg);
  return (0, import_crypto.publicEncrypt)({ key: keyObject, oaepHash, padding }, cek);
};
const decrypt = (alg, key, encryptedKey) => {
  const padding = resolvePadding(alg);
  const oaepHash = resolveOaepHash(alg);
  const keyObject = ensureKeyObject(key, alg, "unwrapKey", "decrypt");
  checkKey(keyObject, alg);
  return (0, import_crypto.privateDecrypt)({ key: keyObject, oaepHash, padding }, encryptedKey);
};
module.exports = __toCommonJS(rsaes_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  decrypt,
  encrypt
});
