var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var verify_exports = {};
__export(verify_exports, {
  default: () => verify_default
});
var crypto = __toESM(require("crypto"));
var import_util = require("util");
var import_dsa_digest = __toESM(require("./dsa_digest.js"));
var import_node_key = __toESM(require("./node_key.js"));
var import_sign = __toESM(require("./sign.js"));
var import_get_sign_verify_key = __toESM(require("./get_sign_verify_key.js"));
const [major, minor] = process.version.slice(1).split(".").map((str) => parseInt(str, 10));
const oneShotCallbackSupported = major >= 16 || major === 15 && minor >= 13;
let oneShotVerify;
if (crypto.verify.length > 4 && oneShotCallbackSupported) {
  oneShotVerify = (0, import_util.promisify)(crypto.verify);
} else {
  oneShotVerify = crypto.verify;
}
const verify = async (alg, key, signature, data) => {
  const keyObject = (0, import_get_sign_verify_key.default)(alg, key, "verify");
  if (alg.startsWith("HS")) {
    const expected = await (0, import_sign.default)(alg, keyObject, data);
    const actual = signature;
    try {
      return crypto.timingSafeEqual(actual, expected);
    } catch {
      return false;
    }
  }
  const algorithm = (0, import_dsa_digest.default)(alg);
  const keyInput = (0, import_node_key.default)(alg, keyObject);
  try {
    return await oneShotVerify(algorithm, data, keyInput, signature);
  } catch {
    return false;
  }
};
var verify_default = verify;
module.exports = __toCommonJS(verify_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
