var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var decode_jwt_exports = {};
__export(decode_jwt_exports, {
  decodeJwt: () => decodeJwt
});
var import_base64url = require("./base64url.js");
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_is_object = __toESM(require("../lib/is_object.js"));
var import_errors = require("./errors.js");
function decodeJwt(jwt) {
  if (typeof jwt !== "string")
    throw new import_errors.JWTInvalid("JWTs must use Compact JWS serialization, JWT must be a string");
  const { 1: payload, length } = jwt.split(".");
  if (length === 5)
    throw new import_errors.JWTInvalid("Only JWTs using Compact JWS serialization can be decoded");
  if (length !== 3)
    throw new import_errors.JWTInvalid("Invalid JWT");
  if (!payload)
    throw new import_errors.JWTInvalid("JWTs must contain a payload");
  let decoded;
  try {
    decoded = (0, import_base64url.decode)(payload);
  } catch {
    throw new import_errors.JWTInvalid("Failed to parse the base64url encoded payload");
  }
  let result;
  try {
    result = JSON.parse(import_buffer_utils.decoder.decode(decoded));
  } catch {
    throw new import_errors.JWTInvalid("Failed to parse the decoded payload as JSON");
  }
  if (!(0, import_is_object.default)(result))
    throw new import_errors.JWTInvalid("Invalid JWT Claims Set");
  return result;
}
module.exports = __toCommonJS(decode_jwt_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  decodeJwt
});
