var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import epoch from "../lib/epoch.js";
import isObject from "../lib/is_object.js";
import secs from "../lib/secs.js";
class ProduceJWT {
  constructor(payload) {
    if (!isObject(payload)) {
      throw new TypeError("JWT Claims Set MUST be an object");
    }
    this._payload = payload;
  }
  setIssuer(issuer) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { iss: issuer });
    return this;
  }
  setSubject(subject) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { sub: subject });
    return this;
  }
  setAudience(audience) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { aud: audience });
    return this;
  }
  setJti(jwtId) {
    this._payload = __spreadProps(__spreadValues({}, this._payload), { jti: jwtId });
    return this;
  }
  setNotBefore(input) {
    if (typeof input === "number") {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { nbf: input });
    } else {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { nbf: epoch(new Date()) + secs(input) });
    }
    return this;
  }
  setExpirationTime(input) {
    if (typeof input === "number") {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { exp: input });
    } else {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { exp: epoch(new Date()) + secs(input) });
    }
    return this;
  }
  setIssuedAt(input) {
    if (typeof input === "undefined") {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { iat: epoch(new Date()) });
    } else {
      this._payload = __spreadProps(__spreadValues({}, this._payload), { iat: input });
    }
    return this;
  }
}
export {
  ProduceJWT
};
