var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var decrypt_exports = {};
__export(decrypt_exports, {
  flattenedDecrypt: () => flattenedDecrypt
});
var import_base64url = require("../../runtime/base64url.js");
var import_decrypt = __toESM(require("../../runtime/decrypt.js"));
var import_zlib = require("../../runtime/zlib.js");
var import_errors = require("../../util/errors.js");
var import_is_disjoint = __toESM(require("../../lib/is_disjoint.js"));
var import_is_object = __toESM(require("../../lib/is_object.js"));
var import_decrypt_key_management = __toESM(require("../../lib/decrypt_key_management.js"));
var import_buffer_utils = require("../../lib/buffer_utils.js");
var import_cek = __toESM(require("../../lib/cek.js"));
var import_validate_crit = __toESM(require("../../lib/validate_crit.js"));
var import_validate_algorithms = __toESM(require("../../lib/validate_algorithms.js"));
async function flattenedDecrypt(jwe, key, options) {
  if (!(0, import_is_object.default)(jwe)) {
    throw new import_errors.JWEInvalid("Flattened JWE must be an object");
  }
  if (jwe.protected === void 0 && jwe.header === void 0 && jwe.unprotected === void 0) {
    throw new import_errors.JWEInvalid("JOSE Header missing");
  }
  if (typeof jwe.iv !== "string") {
    throw new import_errors.JWEInvalid("JWE Initialization Vector missing or incorrect type");
  }
  if (typeof jwe.ciphertext !== "string") {
    throw new import_errors.JWEInvalid("JWE Ciphertext missing or incorrect type");
  }
  if (typeof jwe.tag !== "string") {
    throw new import_errors.JWEInvalid("JWE Authentication Tag missing or incorrect type");
  }
  if (jwe.protected !== void 0 && typeof jwe.protected !== "string") {
    throw new import_errors.JWEInvalid("JWE Protected Header incorrect type");
  }
  if (jwe.encrypted_key !== void 0 && typeof jwe.encrypted_key !== "string") {
    throw new import_errors.JWEInvalid("JWE Encrypted Key incorrect type");
  }
  if (jwe.aad !== void 0 && typeof jwe.aad !== "string") {
    throw new import_errors.JWEInvalid("JWE AAD incorrect type");
  }
  if (jwe.header !== void 0 && !(0, import_is_object.default)(jwe.header)) {
    throw new import_errors.JWEInvalid("JWE Shared Unprotected Header incorrect type");
  }
  if (jwe.unprotected !== void 0 && !(0, import_is_object.default)(jwe.unprotected)) {
    throw new import_errors.JWEInvalid("JWE Per-Recipient Unprotected Header incorrect type");
  }
  let parsedProt;
  if (jwe.protected) {
    const protectedHeader2 = (0, import_base64url.decode)(jwe.protected);
    try {
      parsedProt = JSON.parse(import_buffer_utils.decoder.decode(protectedHeader2));
    } catch {
      throw new import_errors.JWEInvalid("JWE Protected Header is invalid");
    }
  }
  if (!(0, import_is_disjoint.default)(parsedProt, jwe.header, jwe.unprotected)) {
    throw new import_errors.JWEInvalid("JWE Protected, JWE Unprotected Header, and JWE Per-Recipient Unprotected Header Parameter names must be disjoint");
  }
  const joseHeader = {
    ...parsedProt,
    ...jwe.header,
    ...jwe.unprotected
  };
  (0, import_validate_crit.default)(import_errors.JWEInvalid, /* @__PURE__ */ new Map(), options?.crit, parsedProt, joseHeader);
  if (joseHeader.zip !== void 0) {
    if (!parsedProt || !parsedProt.zip) {
      throw new import_errors.JWEInvalid('JWE "zip" (Compression Algorithm) Header MUST be integrity protected');
    }
    if (joseHeader.zip !== "DEF") {
      throw new import_errors.JOSENotSupported('Unsupported JWE "zip" (Compression Algorithm) Header Parameter value');
    }
  }
  const { alg, enc } = joseHeader;
  if (typeof alg !== "string" || !alg) {
    throw new import_errors.JWEInvalid("missing JWE Algorithm (alg) in JWE Header");
  }
  if (typeof enc !== "string" || !enc) {
    throw new import_errors.JWEInvalid("missing JWE Encryption Algorithm (enc) in JWE Header");
  }
  const keyManagementAlgorithms = options && (0, import_validate_algorithms.default)("keyManagementAlgorithms", options.keyManagementAlgorithms);
  const contentEncryptionAlgorithms = options && (0, import_validate_algorithms.default)("contentEncryptionAlgorithms", options.contentEncryptionAlgorithms);
  if (keyManagementAlgorithms && !keyManagementAlgorithms.has(alg)) {
    throw new import_errors.JOSEAlgNotAllowed('"alg" (Algorithm) Header Parameter not allowed');
  }
  if (contentEncryptionAlgorithms && !contentEncryptionAlgorithms.has(enc)) {
    throw new import_errors.JOSEAlgNotAllowed('"enc" (Encryption Algorithm) Header Parameter not allowed');
  }
  let encryptedKey;
  if (jwe.encrypted_key !== void 0) {
    encryptedKey = (0, import_base64url.decode)(jwe.encrypted_key);
  }
  let resolvedKey = false;
  if (typeof key === "function") {
    key = await key(parsedProt, jwe);
    resolvedKey = true;
  }
  let cek;
  try {
    cek = await (0, import_decrypt_key_management.default)(alg, key, encryptedKey, joseHeader);
  } catch (err) {
    if (err instanceof TypeError) {
      throw err;
    }
    cek = (0, import_cek.default)(enc);
  }
  const iv = (0, import_base64url.decode)(jwe.iv);
  const tag = (0, import_base64url.decode)(jwe.tag);
  const protectedHeader = import_buffer_utils.encoder.encode(jwe.protected ?? "");
  let additionalData;
  if (jwe.aad !== void 0) {
    additionalData = (0, import_buffer_utils.concat)(protectedHeader, import_buffer_utils.encoder.encode("."), import_buffer_utils.encoder.encode(jwe.aad));
  } else {
    additionalData = protectedHeader;
  }
  let plaintext = await (0, import_decrypt.default)(enc, cek, (0, import_base64url.decode)(jwe.ciphertext), iv, tag, additionalData);
  if (joseHeader.zip === "DEF") {
    plaintext = await (options?.inflateRaw || import_zlib.inflate)(plaintext);
  }
  const result = { plaintext };
  if (jwe.protected !== void 0) {
    result.protectedHeader = parsedProt;
  }
  if (jwe.aad !== void 0) {
    result.additionalAuthenticatedData = (0, import_base64url.decode)(jwe.aad);
  }
  if (jwe.unprotected !== void 0) {
    result.sharedUnprotectedHeader = jwe.unprotected;
  }
  if (jwe.header !== void 0) {
    result.unprotectedHeader = jwe.header;
  }
  if (resolvedKey) {
    return { ...result, key };
  }
  return result;
}
module.exports = __toCommonJS(decrypt_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  flattenedDecrypt
});
