var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var ecdhes_exports = {};
__export(ecdhes_exports, {
  deriveKey: () => deriveKey,
  ecdhAllowed: () => ecdhAllowed,
  generateEpk: () => generateEpk
});
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_webcrypto = __toESM(require("./webcrypto.js"));
var import_crypto_key = require("../lib/crypto_key.js");
var import_digest = __toESM(require("./digest.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
async function deriveKey(publicKey, privateKey, algorithm, keyLength, apu = new Uint8Array(0), apv = new Uint8Array(0)) {
  if (!(0, import_webcrypto.isCryptoKey)(publicKey)) {
    throw new TypeError((0, import_invalid_key_input.default)(publicKey, ...import_is_key_like.types));
  }
  (0, import_crypto_key.checkEncCryptoKey)(publicKey, "ECDH-ES");
  if (!(0, import_webcrypto.isCryptoKey)(privateKey)) {
    throw new TypeError((0, import_invalid_key_input.default)(privateKey, ...import_is_key_like.types));
  }
  (0, import_crypto_key.checkEncCryptoKey)(privateKey, "ECDH-ES", "deriveBits", "deriveKey");
  const value = (0, import_buffer_utils.concat)((0, import_buffer_utils.lengthAndInput)(import_buffer_utils.encoder.encode(algorithm)), (0, import_buffer_utils.lengthAndInput)(apu), (0, import_buffer_utils.lengthAndInput)(apv), (0, import_buffer_utils.uint32be)(keyLength));
  if (!privateKey.usages.includes("deriveBits")) {
    throw new TypeError('ECDH-ES private key "usages" must include "deriveBits"');
  }
  const sharedSecret = new Uint8Array(await import_webcrypto.default.subtle.deriveBits({
    name: "ECDH",
    public: publicKey
  }, privateKey, Math.ceil(parseInt(privateKey.algorithm.namedCurve.slice(-3), 10) / 8) << 3));
  return (0, import_buffer_utils.concatKdf)(import_digest.default, sharedSecret, keyLength, value);
}
async function generateEpk(key) {
  if (!(0, import_webcrypto.isCryptoKey)(key)) {
    throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types));
  }
  return import_webcrypto.default.subtle.generateKey(key.algorithm, true, ["deriveBits"]);
}
function ecdhAllowed(key) {
  if (!(0, import_webcrypto.isCryptoKey)(key)) {
    throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types));
  }
  return ["P-256", "P-384", "P-521"].includes(key.algorithm.namedCurve);
}
module.exports = __toCommonJS(ecdhes_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  deriveKey,
  ecdhAllowed,
  generateEpk
});
