var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var pbes2kw_exports = {};
__export(pbes2kw_exports, {
  decrypt: () => decrypt,
  encrypt: () => encrypt
});
var import_random = __toESM(require("./random.js"));
var import_buffer_utils = require("../lib/buffer_utils.js");
var import_base64url = require("./base64url.js");
var import_aeskw = require("./aeskw.js");
var import_check_p2s = __toESM(require("../lib/check_p2s.js"));
var import_webcrypto = __toESM(require("./webcrypto.js"));
var import_crypto_key = require("../lib/crypto_key.js");
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
function getCryptoKey(key, alg) {
  if (key instanceof Uint8Array) {
    return import_webcrypto.default.subtle.importKey("raw", key, "PBKDF2", false, ["deriveBits"]);
  }
  if ((0, import_webcrypto.isCryptoKey)(key)) {
    (0, import_crypto_key.checkEncCryptoKey)(key, alg, "deriveBits", "deriveKey");
    return key;
  }
  throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types, "Uint8Array"));
}
async function deriveKey(p2s, alg, p2c, key) {
  (0, import_check_p2s.default)(p2s);
  const salt = (0, import_buffer_utils.p2s)(alg, p2s);
  const keylen = parseInt(alg.slice(13, 16), 10);
  const subtleAlg = {
    hash: `SHA-${alg.slice(8, 11)}`,
    iterations: p2c,
    name: "PBKDF2",
    salt
  };
  const wrapAlg = {
    length: keylen,
    name: "AES-KW"
  };
  const cryptoKey = await getCryptoKey(key, alg);
  if (cryptoKey.usages.includes("deriveBits")) {
    return new Uint8Array(await import_webcrypto.default.subtle.deriveBits(subtleAlg, cryptoKey, keylen));
  }
  if (cryptoKey.usages.includes("deriveKey")) {
    return import_webcrypto.default.subtle.deriveKey(subtleAlg, cryptoKey, wrapAlg, false, ["wrapKey", "unwrapKey"]);
  }
  throw new TypeError('PBKDF2 key "usages" must include "deriveBits" or "deriveKey"');
}
const encrypt = async (alg, key, cek, p2c = Math.floor(Math.random() * 2049) + 2048, p2s = (0, import_random.default)(new Uint8Array(16))) => {
  const derived = await deriveKey(p2s, alg, p2c, key);
  const encryptedKey = await (0, import_aeskw.wrap)(alg.slice(-6), derived, cek);
  return { encryptedKey, p2c, p2s: (0, import_base64url.encode)(p2s) };
};
const decrypt = async (alg, key, encryptedKey, p2c, p2s) => {
  const derived = await deriveKey(p2s, alg, p2c, key);
  return (0, import_aeskw.unwrap)(alg.slice(-6), derived, encryptedKey);
};
module.exports = __toCommonJS(pbes2kw_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  decrypt,
  encrypt
});
