var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);
var rsaes_exports = {};
__export(rsaes_exports, {
  decrypt: () => decrypt,
  encrypt: () => encrypt
});
var import_subtle_rsaes = __toESM(require("./subtle_rsaes.js"));
var import_bogus = __toESM(require("./bogus.js"));
var import_webcrypto = __toESM(require("./webcrypto.js"));
var import_crypto_key = require("../lib/crypto_key.js");
var import_check_key_length = __toESM(require("./check_key_length.js"));
var import_invalid_key_input = __toESM(require("../lib/invalid_key_input.js"));
var import_is_key_like = require("./is_key_like.js");
const encrypt = async (alg, key, cek) => {
  if (!(0, import_webcrypto.isCryptoKey)(key)) {
    throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types));
  }
  (0, import_crypto_key.checkEncCryptoKey)(key, alg, "encrypt", "wrapKey");
  (0, import_check_key_length.default)(alg, key);
  if (key.usages.includes("encrypt")) {
    return new Uint8Array(await import_webcrypto.default.subtle.encrypt((0, import_subtle_rsaes.default)(alg), key, cek));
  }
  if (key.usages.includes("wrapKey")) {
    const cryptoKeyCek = await import_webcrypto.default.subtle.importKey("raw", cek, ...import_bogus.default);
    return new Uint8Array(await import_webcrypto.default.subtle.wrapKey("raw", cryptoKeyCek, key, (0, import_subtle_rsaes.default)(alg)));
  }
  throw new TypeError('RSA-OAEP key "usages" must include "encrypt" or "wrapKey" for this operation');
};
const decrypt = async (alg, key, encryptedKey) => {
  if (!(0, import_webcrypto.isCryptoKey)(key)) {
    throw new TypeError((0, import_invalid_key_input.default)(key, ...import_is_key_like.types));
  }
  (0, import_crypto_key.checkEncCryptoKey)(key, alg, "decrypt", "unwrapKey");
  (0, import_check_key_length.default)(alg, key);
  if (key.usages.includes("decrypt")) {
    return new Uint8Array(await import_webcrypto.default.subtle.decrypt((0, import_subtle_rsaes.default)(alg), key, encryptedKey));
  }
  if (key.usages.includes("unwrapKey")) {
    const cryptoKeyCek = await import_webcrypto.default.subtle.unwrapKey("raw", encryptedKey, key, (0, import_subtle_rsaes.default)(alg), ...import_bogus.default);
    return new Uint8Array(await import_webcrypto.default.subtle.exportKey("raw", cryptoKeyCek));
  }
  throw new TypeError('RSA-OAEP key "usages" must include "decrypt" or "unwrapKey" for this operation');
};
module.exports = __toCommonJS(rsaes_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  decrypt,
  encrypt
});
